package SliMP3::cs4341;

# $Id: cs4341.pm,v 1.2 2001/11/14 08:25:23 slimdevices Exp $

# SliMP3 Server Copyright (C) 2001 Sean Adams, Slim Devices Inc.
# This program is free software; you can redistribute it and/or
# modify it under the terms of the GNU General Public License, 
# version 2.

# This is currently unused.

use strict;

my %csRegisters   = ();
my $isInitialized = 0;

sub init {

	while (<DATA>) {
		chomp;
		next if /^#/;
		next if /^\s*$/;

		s/#.*//;

		my ($address, $label) = split(' ');

		$csRegisters{$label}  = $address;
	}

	$isInitialized = 1;
}

sub csWrite {
	my ($key,$data) = @_;

	init() unless $isInitialized;

	die "Unknown CS4341 setting: $key\n" unless (defined $csRegisters{$key});

	my $i2c = "s $csRegisters{'devwrite'} $csRegisters{$key} $data p";
	   $i2c=~s/ //g;

	# pack hex values and add write commands
	$i2c =~ s/([\dA-Fa-f][\dA-Fa-f])/'w'.pack ("C", hex ($1))/eg;

	return $i2c;
}

sub csRead {
	init() unless $isInitialized;

	my $i2c = "s $csRegisters{'devread'} r n p";
	   $i2c =~ s/ //g;

	# pack hex values and add write, ack commands
	$i2c =~ s/([\dA-Fa-f][\dA-Fa-f])/'w'.pack ("C", hex ($1))/eg;

	return $i2c;
}

1;

__DATA__
# 
# CS4341 Registers
#
#
# Device address is 001000 . AD0 . R/W
#
# Device addresses for AD0 connected to ground
#
20 devwrite
21 devread
#
# For AD0 connected to +5V:
#22 devwrite
#23 devread

00 MCLK
01 Mode
02 Mixing
03 VolA
04 VolB

#
# Command format is:  START DEVADDR REGADDR DATA
#
